import httpRequest from '@/utils/axios'

/**
 * 搜索统一用户
 */
export function search(params) {
  return httpRequest.get('/api/marketing/admin/v1/system/search-user', { params })
}

/**
 * 获取授权用户
 */
export function getUserList(params) {
  return httpRequest.get('/api/marketing/admin/v1/users', { params })
}
/**
 * 授权用户
 */
export function addUser(data) {
  return httpRequest.post('/api/marketing/admin/v1/user', data)
}
/**
 * 批量删除授权用户
 */
export function batchDeleteUser(data) {
  return httpRequest.post('/api/marketing/admin/v1/user/batch-delete', data)
}
/**
 * 获取角色列表
 */
export function getRoleList(params) {
  return httpRequest.get('/api/marketing/admin/v1/system/roles', { params })
}
/**
 * 创建角色
 */
export function addRole(data) {
  return httpRequest.post('/api/marketing/admin/v1/system/role', data)
}
/**
 * 更新角色
 */
export function updateRole(id, data) {
  return httpRequest.put(`/api/marketing/admin/v1/system/role/${id}/update`, data)
}
/**
 * 批量删除角色
 */
export function batchDeleteRole(data) {
  return httpRequest.post('/api/marketing/admin/v1/system/role/batch-delete', data)
}
/**
 * 分配角色给用户
 */
export function addRoleUsers(data) {
  return httpRequest.post('/api/marketing/admin/v1/system/assign/roles-to-user', data)
}
/**
 * 获取角色下用户列表
 */
export function getRoleUserList(params) {
  return httpRequest.get(`/api/marketing/admin/v1/system/assign/role/${params.role_id}/users`, { params })
}
/**
 * 批量删除角色下用户
 */
export function batchDeleteRoleUsers(data) {
  return httpRequest.post('/api/marketing/admin/v1/system/assign/remove-user-form-role', data)
}

/**
 * 保存使用手册
 */
export function keepUserManual(data) {
  return httpRequest.post('/api/marketing/admin/v1/system/user-manual', data)
}
/**
 * 获取使用手册
 */
export function getUserManual() {
  return httpRequest.get('/api/marketing/admin/v1/system/user-manual')
}